WebApp/Models/CancelReservationVM.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebApp.Models
{
    public class CancelReservationVM
    {
        public string ReservationNb { get; set; }
        public string Firstname { get; set; }
        public string Lastname { get; set; }
    }
}

WebApp/Models/ErrorViewModel.cs
using System;

namespace WebApp.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

WebApp/Models/HomeVM.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebApp.Models
{
    public class HomeVM
    {
        public List<string> Locations{get;set;}
        public string Firstname { get; set; }
        public string Lastname { get; set; }
        public string ReservationNb { get; set; }
    }
}

WebApp/Models/ReservationVM.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebApp.Models
{
    public class ReservationVM
    {
        public int IdRoom { get; set; }
        public string DateStart { get; set; }
        public string DateEnd { get; set; }
        public decimal Price { get; set; }
    }
}

WebApp/Models/RoomVM.cs
using DTO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebApp.Models
{
    public class RoomVM
    {
        public DateTime DateStart { get; set; }
        public DateTime DateEnd { get; set; }
        public List<Room> Rooms { get; set; }

    }
}

WebApp/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using BLL;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using WebApp.Models;

namespace WebApp.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        private IHotelManager HotelManager { get; }
        public HomeController(ILogger<HomeController> logger, IHotelManager hotelManager)
        {
            _logger = logger;
            HotelManager = hotelManager;
        }

        public IActionResult Index(string firstname, string lastname, string reservationNb)
        {
            var vm = new HomeVM { Locations = HotelManager.GetLocations(), Firstname=firstname, Lastname=lastname, ReservationNb=reservationNb };
        
            return View(vm);
        }

        [HttpPost]
        public IActionResult Index(DateTime dateStart, DateTime dateEnd, string location)
        {
            if (dateEnd <= dateStart)
            {               
                return RedirectToAction("Index", "Home");
            }    
            
            return RedirectToAction("Index", "Rooms", new { dateStart = dateStart, dateEnd = dateEnd, location = location });
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

WebApp/Controllers/HotelsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BLL;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace WebApp.Controllers
{
    public class HotelsController : Controller
    {
        private IHotelManager HotelManager { get; }
        public HotelsController(IHotelManager hotelManager) {
            HotelManager = hotelManager;
        }
        // GET: HotelsController
        public ActionResult Index()
        {
            var hotels = HotelManager.GetAll();
            return View(hotels);
        }

        // GET: HotelsController/Details/5
        public ActionResult Details(int id, DateTime dateStart, DateTime dateEnd)
        {
            var hotel = HotelManager.GetHotel(id);
            return View(hotel);
        }       
    }
}

WebApp/Controllers/ReservationController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BLL;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using WebApp.Models;

namespace WebApp.Controllers
{
    public class ReservationController : Controller
    {
        private IReservationManager ReservationManager { get; set; }
        public ReservationController(IReservationManager reservationManager)
        {
            ReservationManager = reservationManager;
        }

        // GET: ReservationController
        public ActionResult Index(int id, DateTime dateStart, DateTime dateEnd, decimal price)
        {
            price = price * (decimal)(dateEnd - dateStart).TotalDays;
            var vm = new ReservationVM { IdRoom = id, DateStart = dateStart.ToString("dd.MM.yyyy"), DateEnd = dateEnd.ToString("dd.MM.yyyy"), Price = price };

            return View(vm);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Index(string fname, string lname, string email, ReservationVM vm)
        {
            try
            {
                string reservationNb;

                DateTime DateStart = DateTime.ParseExact(vm.DateStart, "MM/dd/yyyy HH:mm:ss", null);
                DateTime DateEnd = DateTime.ParseExact(vm.DateEnd, "MM/dd/yyyy HH:mm:ss", null);

                reservationNb = ReservationManager.AddReservation(vm.IdRoom, fname, lname, email, DateStart, DateEnd, vm.Price);

                return View("Confirmation", reservationNb);

            }
            catch
            {
                ModelState.AddModelError(string.Empty, "Erreur");
                return View();
            }
        }

        [HttpPost]
        public IActionResult Cancel(string reservationNb, string firstname, string lastname)
        {
            var vm = new CancelReservationVM { ReservationNb = reservationNb, Firstname = firstname, Lastname = lastname };
            return View(vm);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Confirmation(string Firstname, string Lastname, string ReservationNb)
        {
            try
            {
                if (ReservationManager.CancelReservation(Firstname, Lastname, ReservationNb))
                    return View("CancelConfirmation");
                //Possible avec Javascript ou bootstrap
                else
                {
                    
                    return RedirectToAction("Index", "Home", new { Firstname = Firstname, Lastname = Lastname, ReservationNb = ReservationNb });
                }
            }
            catch
            {
                return View("Index", "Home");
            }
        }
    }
}

WebApp/Controllers/RoomsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BLL;
using DTO;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using WebApp.Models;

namespace WebApp.Controllers
{
    public class RoomsController : Controller
    {
        private IRoomManager RoomManager;

        public RoomsController (IRoomManager roomManager)
        {
            RoomManager = roomManager;
        }

        // GET: RoomsController
        public ActionResult Index(DateTime dateStart, DateTime dateEnd, String location)
        {
            var rooms = RoomManager.Search(dateStart, dateEnd, location);

            //ModelState.AddModelError()
            var vm = new RoomVM { DateStart = dateStart, DateEnd = dateEnd, Rooms = rooms};

            return View(vm);
        }
    }
}

WebApp/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}
@model HomeVM

<div class="text-center">
    <h1 class="display-4">Valais Booking</h1>
    <p>Enjoy the beauty of the montains !</p>
</div>
<br>
<div class="container w-25" style="background-color:azure;">
    <div class="text-center">
        <h3>Quick research</h3>

        <form asp-action="index">
            <label for="fname">From (date) :</label><br>
            <input type="date" id="datePickerIdStart" name="dateStart" required><br>
            <label for="lname">To (date) :</label><br>
            <input type="date" id="datePickerIdEnd" name="dateEnd" required><br>
            <label for="lname">Location :</label><br>
            <!--Liste déroulante avec les locations existantes dans la BDD-->
            <select id="locations" name="location">
                @foreach (var item in Model.Locations)
                {
                    <option value="@Html.DisplayName(item)">@Html.DisplayName(item)</option>
                }
            </select>
            <br><br>
            <input type="submit" value="Search !">
        </form>
    </div>
    <br />
    <div class="text-center">
        <form asp-action="cancel" asp-controller="reservation">
            <h3>Cancel a reservation</h3>
            <label asp-for="ReservationNb">Reservation number :</label><br>
            <input asp-for="ReservationNb" maxlength="10" required><br>
            <label asp-for="Firstname">Firstname :</label><br>
            <input asp-for="Firstname" required><br>
            <label asp-for="Lastname">Lastname :</label><br>
            <input asp-for="Lastname" required><br>
            <br><br>
            <input type="submit" value="Next">
        </form>
    </div>
</div>

    <script>
        datePickerIdStart.min = new Date().toISOString().split("T")[0];
        datePickerIdEnd.min = new Date().toISOString().split("T")[0];
    </script>

WebApp/Views/Hotels/Details.cshtml
@model DTO.Hotel

@{
    ViewData["Title"] = "Details";
}

<h1>Details</h1>

<div>
    <h4>Hotel</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Description)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Description)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Location)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Location)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Stars)
        </dt>
        <dd class="col-sm-10">
            @for (int i = 0; i < Model.Stars; i++)
            {
                <t>&#x2B50</t>
            }
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.HasWifi)
        </dt>
        <dd class="col-sm-10">
            @if (Model.HasWifi)
            {
                <t>&#x2705</t>
            }
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.HasParking)
        </dt>
        <dd class="col-sm-10">
            @if (Model.HasParking)
            {
                <t>&#x2705</t>
            }
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Phone)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Phone)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Email)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Email)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Website)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Website)
        </dd>
    </dl>
</div>
<div>
    <a href="javascript:history.back()" class="btn btn-light" role="button" aria-pressed="true" style="margin: 10px">Back</a>
</div>

WebApp/Views/Hotels/Index.cshtml
@model IEnumerable<DTO.Hotel>

@{
    ViewData["Title"] = "Index";
}

<h1>Hotels available in our app</h1>


<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Name)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Description)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Location)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Stars)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Name)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Description)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Location)
            </td>
            <td>
                @for (int i = 0; i < item.Stars; i++)
                {
                    <t>&#x2B50</t>
                }
            </td>
            <td>
                @Html.ActionLink("Details", "Details", new { id=item.IdHotel })
            </td>
        </tr>
}
    </tbody>
</table>

WebApp/Views/Reservation/Cancel.cshtml
@model WebApp.Models.CancelReservationVM

@{
    ViewData["Title"] = "Cancel";
}

<h1>Cancel a reservation</h1>

<div style="background-color:azure; padding:20px">
    <h4>Are you sure you want to delete this reservation?</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.ReservationNb)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.ReservationNb)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Firstname)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Firstname)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Lastname)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Lastname)
        </dd>
    </dl>
    
    <form asp-action="Confirmation">
        <input asp-for="Firstname" type="hidden" />
        <input asp-for="Lastname" type="hidden" />
        <input asp-for="ReservationNb" type="hidden" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>

WebApp/Views/Reservation/CancelConfirmation.cshtml
@{
    ViewData["Title"] = "CancelConfirmation";
}

<div class="alert-info" style="padding:20px">
    <br />
    <h3>Your reservation has been canceled !</h3>
    <br />
    <h3>You will receive a confirmation by email</h3>
</div>
<br />
<div class="align-content-center">
    <a class="btn" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
</div>

WebApp/Views/Reservation/Confirmation.cshtml
@model string

@{
    ViewData["Title"] = "Index";
}

<div class="alert-info" style="padding:20px">
    <h3>Reservation confrirmed !</h3>
    <h2>Your reservation number is : @Html.DisplayName(Model)</h2>
    <br />
    <h3>You will receive a confirmation by email</h3>
</div>
<br />
<div class="align-content-center" >
    <a class="btn" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
</div>

WebApp/Views/Reservation/Index.cshtml
@model WebApp.Models.ReservationVM

@{
    ViewData["Title"] = "Index";
}

<h4>Book this reservation ?</h4>
<hr />
<div class="row">
    <div class="col-md-4" style="background-color:azure">
        <form asp-action="Index">
            <input asp-for="IdRoom" type="hidden" />
            <input asp-for="DateStart" type="hidden" />
            <input asp-for="DateEnd" type="hidden" />
            <input asp-for="Price" type="hidden" />
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label for="fname" class="control-label">Firstname</label>
                <input type="text" name="fname" class="form-control" required />
            </div>
            <div class="form-group">
                <label for="lname" class="control-label">Lastname</label>
                <input type="text" name="lname" class="form-control" required />
            </div>
            <div class="form-group">
                <label for="email" class="control-label">Email</label>
                <input type="text" name="email" class="form-control" required />
            </div>
            <div class="form-group">
                <label class="control-label">From :</label>
                <span class="form-control">@Html.DisplayFor(model => model.DateStart)
            </span>

            </div>
            <div class="form-group">
                <label class="control-label">To :</label>
                <span class="form-control">@Html.DisplayFor(model => model.DateEnd)
                </span>
            </div>
            <div class="form-group">
                <label class="control-label">Total Price :</label>
                <span class="form-control">@Html.DisplayFor(model => model.Price) CHF
                </span>
            </div>
            <br />

            <div class="form-group">
                <input type="submit" value="Confirm reservation" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a href="javascript:history.back()" class="btn btn-light" role="button" aria-pressed="true" style="margin: 10px">Back</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

WebApp/Views/Rooms/Index.cshtml
@model RoomVM

@{
    ViewData["Title"] = "Index";
}


@if (Model.Rooms is null)
{
    <div class="alert-info">
        <br />
        <h3>Unfortunatly no room availble for this period</h3>
        <br />
        <h3>Please try with other dates</h3>
    </div>
    <br />
    <div class="align-content-center">
        <a class="btn" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
    </div>
}
else
{
    <!--Prends la location du premier objet (qui est la même partout)-->
    <h1>Rooms available in @Html.DisplayFor(model => model.Rooms.First().Hotel.Location)</h1>

        <table class="table">
            <thead>
                <tr>
                    <th>
                        Hotel
                    </th>
                    <th>
                        Stars
                    </th>
                    <th>
                        Type
                    </th>
                    <th>
                        Description
                    </th>
                    <th>
                        HasTV
                    </th>
                    <th>
                        HasHairDryer
                    </th>
                    <th>
                        Price per night
                    </th>
                    <th>
                        Pictures
                    </th>
                    <th></th>
                </tr>
            </thead>
            <tbody>

                @foreach (var item in Model.Rooms)
                {
                    <tr>
                        <td>
                            @Html.ActionLink(item.Hotel.Name, "Details", "Hotels", new { id = item.IdHotel, dateStart = Model.DateStart, dateEnd = Model.DateEnd })
                        </td>
                        <td>
                            @for (int i = 0; i < item.Hotel.Stars; i++)
                            {
                                <t>&#x2B50</t>
                            }
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.RoomType.Description)
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Description)
                        </td>
                        <td>
                            @if (item.HasTV)
                            {
                                <t>&#x2705</t>
                            }
                        </td>
                        <td>
                            @if (item.HasHairDryer)
                            {
                                <t>&#x2705</t>
                            }
                        </td>
                        <td>
                            @Html.DisplayFor(modelItem => item.Price) CHF
                        </td>
                        <td>
                            @foreach (var picture in item.Pictures)
                            {
                                <a href="@Html.DisplayFor(modelItem => picture)">
                                    <img src="@Html.DisplayFor(modelItem => picture)" alt="Picture" class="mini" />
                                </a>
                            }
                        </td>
                        <td>
                            @Html.ActionLink("Reserve", "Index", "Reservation", new { id = item.IdRoom, dateStart = Model.DateStart, dateEnd = Model.DateEnd, price = item.Price })
                        </td>
                    </tr>
                }


            </tbody>
        </table>
}

WebApp/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Valais-Booking</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light box-shadow mb-3" style="background-color:black">
            <div class="container">
                <a class="navbar-brand text-white" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-white" asp-area="" asp-controller="Hotels" asp-action="Index">Hotels</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">       
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>